/* 
 * Autor:             Alexander Gossen
 * Modul:             Masterarbeit
 * Projekt:           Medizinstation
 * Bemerkung:         Hauptprogramm des Projektes Medizinstation
 * Letzte Änderung:   31.10.21
*/

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////// HIER NICHTS ÄNDERN ///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void intervallMessung(){                        

  while(n < 1){                                 // Endlosschleife

    long startzeit = millis();                  // Startet den Timer
   
    do {                                        // Wiederhole solange bis...

      summe += analogRead(pulssensor);          // Addiert bei jedem Durchlauf den Messwert des Sensors und speichert Sie in der Variable Summe
      aktuelle_zeit = millis();                 // Misst die Zeit, die bis zur Erfüllung der Bedingung vergeht
      l = l + 1;                                // Zählt jeden Durchlauf bis die Bedingung erfüllt
      
    }
    while (aktuelle_zeit < startzeit + 20);     // ...bis die Bedingung erfüllt ist

    n = 1;                                      // n wird auf 1 gesetzt

    summe /= l;                                 // Die Summe wird durch die Anzahl der Durchläufe geteilt

  }
}

void messungGlaetten(){                         // Messkurve glätten
  
  summe -= messungen_array[index];              // Der letzte Messwert wird entfernt
  
  messungen_array[index] = summe;               // Die Werte des Pulssensors werden in der Variable sensorwert gespeichert

  summe += messungen_array[index];              // Der aktuelle Messwert wird hinzugefügt

  index++;                                      // Index wird bei jedem Durchlauf um 1 erhöht (bis maximal 20)

  if (index >= messungen){                      // Prüfe, ob 'index' größer die ist als der Wert der variable 'messungen'...

    index = 0;                                  // ... wenn ja, wird die Variable 'index' auf 0 gesetzt
    
  }

  mittelwert = summe / messungen;              // Der Mittelwert wird durch die Formel 'summe' durch 'messungen'

}
